<?php
namespace App\Controllers\V2;

use App\Controllers\BaseController;
use App\Models\common\CodeModel;
use App\Models\v2\M702Model;

class M702 extends BaseController
{
    private $model;
    private $codeModel;
    public function __construct()
    {
        $this->model = new M702Model();
        $this->codeModel = new CodeModel();
    }

    public function lists()
    {
        $codes = $this->codeModel->getCodeLists(['STEP_VERIFICATION', 'VRFCREQ_WAY', 'CP_ID', 'ARTICLE_TYPE']); // 코드조회
        $sido = $this->model->getAreaList(); // 지역조회
        $bonbu = $this->model->getBonbuList();
        $team = $this->model->getTeamList();
        $user = $this->model->getUserList();

        $this->data['codes'] = $codes;
        $this->data['sido'] = $sido;
        $this->data['bonbu'] = $bonbu;
        $this->data['team'] = $team;
        $this->data['user'] = $user;

        return view("pages/v2/m702/lists", $this->data);
    }


    public function getResultList()
    {
        $start = (int) $this->request->getGet('start') ?: 0;
        $end = (int) $this->request->getGet('length') ?: 10;

        $data = [
            'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
            'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
            'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
            'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
            'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
            'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
            'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
            'complete_sdate' => $this->request->getGet('complete_sdate'), // 완료기간1
            'complete_edate' => $this->request->getGet('complete_edate'), // 완료기간2
            'srcSido' => $this->request->getGet('srcSido'), // 시도
            'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
            'srcDong' => $this->request->getGet('srcDong'), // 읍면동
            'bonbu' => $this->request->getGet('bonbu'), // 본부
            'team' => $this->request->getGet('team'), // 팀
            'damdang' => $this->request->getGet('damdang'), // 담당
            'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
            'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
            'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
            'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
            'corp_own' => $this->request->getGet('corp_own'), // 법인
        ];

        $totalCount = $this->model->getTotalCount($data);

        $datas = $this->model->getResultList($start, $end, $data);

        return $this->response->setJSON(body: [
            'recordsTotal' => $totalCount,
            'recordsFiltered' => $totalCount,
            'data' => $datas,
        ]);
    }

    // 엑셀 다운로드
    public function excel()
    {
        try {

            $data = [
                'atcl_no' => $this->request->getGet('atcl_no'), // 매물번호
                'stat_cd' => $this->request->getGet('stat_cd'), // 현재상태
                'realtor_nm' => $this->request->getGet('realtor_nm'), // 중개소
                'charger_gbn' => $this->request->getGet('charger_gbn'), // 배정여부
                'assign_yn' => $this->request->getGet('assign_yn'), // 배정여부2
                'receipt_sdate' => $this->request->getGet('receipt_sdate'), // 접수기간1
                'receipt_edate' => $this->request->getGet('receipt_edate'), // 접수기간2
                'complete_sdate' => $this->request->getGet('complete_sdate'), // 완료기간1
                'complete_edate' => $this->request->getGet('complete_edate'), // 완료기간2
                'srcSido' => $this->request->getGet('srcSido'), // 시도
                'srcGugun' => $this->request->getGet('srcGugun'), // 시군구
                'srcDong' => $this->request->getGet('srcDong'), // 읍면동
                'bonbu' => $this->request->getGet('bonbu'), // 본부
                'team' => $this->request->getGet('team'), // 팀
                'damdang' => $this->request->getGet('damdang'), // 담당
                'vrfcreq_way' => $this->request->getGet('vrfcreq_way'), // 검증방식1
                'vrfc_type_sub' => $this->request->getGet('vrfc_type_sub'), // 검증방식2
                'rcpt_cpid' => $this->request->getGet('rcpt_cpid'), // 매체사
                'rlet_type_cd' => $this->request->getGet('rlet_type_cd'), // 매물종류
                'corp_own' => $this->request->getGet('corp_own'), // 법인
            ];

            $datas = $this->model->getExcelList($data);

            return $this->response->setJSON(body: [
                'data' => $datas,
            ]);

        } catch (\Exception $e) {
            $e->getPrevious()->getTraceAsString();
        }
    }


    // 배정변경
    public function updateAssign()
    {
        try {

            $type = $this->request->getPost('type');
            $rows = $this->request->getPost('rows');
            $damdang = $this->request->getPost(index: 'damdang2');

            $rows = json_decode($rows, true);

            if (count($rows) > 0) {

                foreach ($rows as $row) {

                    $params = [
                        'vr_sq' => $row['vr_sq'],
                        'type' => $type,
                        'damdang' => $damdang,
                    ];

                    // UPDATE v2_article_info, v2_vrfc_req
                    $this->model->updateAssign($params);

                }

            } else {
                return $this->response->setJSON([
                    'code' => '9',
                    'msg' => '데이터 누락'
                ]);
            }


            return $this->response->setJSON([
                'code' => '0',
                'msg' => 'success'
            ]);

        } catch (\Exception $e) {
            return $this->response->setJSON([
                'code' => '9',
                'msg' => $e->getMessage(),
            ]);
        }
    }


    // 상세화면
    public function detail($id)
    {
        $id = (int) $id;

        if ($id <= 0) {
            throw \CodeIgniter\Exceptions\PageNotFoundException::forPageNotFound();
        }

        $codes = $this->codeModel->getCodeLists(['VRFCREQ_WAY', 'CONFIRM_RESULT_D11', 'CONFIRM_RESULT_T11', 'CONSULTANT_COMMENT', 'TEL_FAIL_CAUSE']); // 코드조회

        $record = $this->model->getRecordInfo($id, '1');	// 홍보확인서
        $regist = $this->model->getRecordInfo($id, '2');	// 등기부등본
        $tel = $this->model->getRecordInfo($id, '3'); // 녹취파일
        $memo = $this->model->getMemo($id); // 메모

        $data = $this->model->getDetail($id);
        $history = $this->model->getHistory($id);


        $this->data['codes'] = $codes;

        $this->data['record'] = $record;
        $this->data['regist'] = $regist;
        $this->data['tel'] = $tel;
        $this->data['memo'] = $memo;

        $this->data['data'] = $data;
        $this->data['history'] = $history;

        return view("pages/v2/m702/detail", $this->data);
    }
}